Skip to main content
POST
cURL
A pre-authorization submits a payment for authorization without capturing it. Use capture or void for a subsequent operation against the authorized transaction.

Retry a previous pre-authorization

Use this same endpoint to create a new retry attempt. In the request body, provide retry.originating_id for a previous SmartRetry transaction. You can also import the originating attempt from a payment provider by providing retry.provider_key and either retry.provider_transaction_id or a non-empty retry.interactions history.
A retry request creates a new attempt. To safely replay the exact same request after an ambiguous failure, reuse its Idempotency-Key. See Idempotency.
Save the returned transaction_id. The response includes order_id when it is available.

Authorizations

x-api-key
string
header
required

Headers

idempotency-key
string

Optional idempotency key, scoped to terminal + matched route pattern. A replayed request returns the cached response with Idempotency-Replayed: true.

Maximum string length: 255
Pattern: ^[\w-]+$

Path Parameters

terminal_friendly_id
string
required

The unique identifier of the terminal.

Required string length: 6
Pattern: ^[\dA-Za-z]{6}$

Body

application/json

Exactly one of token, provider_token, or order.payment_instrument must be supplied, unless payment_collection is hosted_page.

merchant_transaction_id
string
required

A unique identifier for the transaction generated by the merchant.

Maximum string length: 100
amount
number
required

The amount to be authorized, in major currency units (e.g. 10.00 for $10.00 USD).

Required range: 0.01 <= x <= 999999.99
currency
enum<string>
required
Available options:
AED,
AFN,
ALL,
AMD,
ANG,
AOA,
ARS,
AUD,
AWG,
AZN,
BAM,
BBD,
BDT,
BGN,
BHD,
BIF,
BMD,
BND,
BOB,
BOV,
BRL,
BSD,
BTN,
BWP,
BYN,
BZD,
CAD,
CDF,
CHE,
CHF,
CHW,
CLF,
CLP,
CNY,
COP,
COU,
CRC,
CUC,
CUP,
CVE,
CZK,
DJF,
DKK,
DOP,
DZD,
EGP,
ERN,
ETB,
EUR,
FJD,
FKP,
GBP,
GEL,
GHS,
GIP,
GMD,
GNF,
GTQ,
GYD,
HKD,
HNL,
HRK,
HTG,
HUF,
IDR,
ILS,
INR,
IQD,
IRR,
ISK,
JMD,
JOD,
JPY,
KES,
KGS,
KHR,
KMF,
KPW,
KRW,
KWD,
KYD,
KZT,
LAK,
LBP,
LKR,
LRD,
LSL,
LYD,
MAD,
MDL,
MGA,
MKD,
MMK,
MNT,
MOP,
MRU,
MUR,
MVR,
MWK,
MXN,
MXV,
MYR,
MZN,
NAD,
NGN,
NIO,
NOK,
NPR,
NZD,
OMR,
PAB,
PEN,
PGK,
PHP,
PKR,
PLN,
PYG,
QAR,
RON,
RSD,
RUB,
RWF,
SAR,
SBD,
SCR,
SDG,
SEK,
SGD,
SHP,
SLL,
SOS,
SRD,
SSP,
STN,
SVC,
SYP,
SZL,
THB,
TJS,
TMT,
TND,
TOP,
TRY,
TTD,
TWD,
TZS,
UAH,
UGX,
USD,
USN,
UYI,
UYU,
UYW,
UZS,
VED,
VES,
VND,
VUV,
WST,
XAF,
XAG,
XAU,
XBA,
XBB,
XBC,
XBD,
XCD,
XDR,
XOF,
XPD,
XPF,
XPT,
XSU,
XTS,
XUA,
XXX,
YER,
ZAR,
ZMW,
ZWL
device_profile
object
browser_profile
object
session
object
order_id
string

A unique identifier for the order generated by SmartRetry. Internally this is the friendly_id for the order and not the actual order_id in the database.

Required string length: 8
Pattern: ^[\dA-Za-z]{8}$
order
object
payer_request_ip_address
string

The IP address of the payer making the request.

Pattern: ^((25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.){3}(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$
ship_indicator
enum<string>
Available options:
01,
02,
03,
04,
05,
06,
07,
08,
09
delivery_address_usage_indicator
string

Indicates how long the shipping address has been associated with the customer.

delivery_timeframe
string

Indicates the delivery timeframe for the order.

shipping_recipient
object
description
string

A description of the pre-authorization.

Maximum string length: 500
token
string

A stored payment token from the merchant's Payment Instruments.

Required string length: 88
provider_token
string

A tokenized payment method reference issued directly by the payment provider (e.g. a Stripe payment_method or Adyen storedPaymentMethodId), forwarded to the processor as-is. Distinct from token, which is a SmartRetry Payment Instrument token.

Required string length: 1 - 255
cvv
string

CVV/CVC of the card. Optional for added security (cannot be stored).

Required string length: 3 - 4
Pattern: ^[0-9]{3,4}$
payment_collection
enum<string>
Available options:
hosted_page

Response

Default Response

transaction_id
string
required
Required string length: 8
Pattern: ^[\dA-Za-z]{8}$
accepted
boolean
required
order_id
string
Required string length: 8
Pattern: ^[\dA-Za-z]{8}$
merchant_transaction_id
string
merchant_order_id
string